|       wdptr = alloca(nbytes);
| like alloc, but automatic
| automatic free upon return from calling function
|
|       This magic trick is performed by taking the space from the
|       frame.

PROBESLOP =	256
SIGSEG    =     11

	.globl _alloca
_alloca:
	pop     bx              | (bx) = return addess
	pop     cx              | (cx) = count
	inc     cx
	and     cx,*/fe         | round up to word
	mov     ax,sp
	sub     ax,cx           | make the room
	sub	ax,#2		| I000 pad to avoid param clash
	cmp     ax,Stkbot
	jb      allo1           | not enough room
	mov     sp,ax
	add	ax,#2		| I000
	jmp     @bx             | return

|       Not enough room on stack (or at least, we don't know for sure)
|       call the OS to grow the stack

allo1:  push    bx                      | save return address
	push    ax                      | save requested new stack size
	xchg    ax,bx                   | (bx) = stack request
	sub     bx,#PROBESLOP
	calli   @Isgadr                 | call routine to remap I-space
	jb      allo3                   | error - stack can't grow
	add     ax,#PROBESLOP/2
	mov     Stkbot,ax
	pop     ax                      | (ax) = new stack pointer
	pop     bx                      | (bx) = saved return addres
	mov     sp,ax
	jmp     @bx

|       sorry, we can't grow the stack anymore.  Send ourselves a
|       "segmentation" signal.

allo3:  call    _getpid                 | (ax) = pid
	push    bp
	mov     bp,sp                   | setup proc preamble in case he
	push    di                      | uses adb to do a traceback
	push    si
	mov     bx,#SIGSEG
	push    bx
	push    ax                      | (pid, SIGSEG)
	call    _kill                   | suicide
	call    __exit                  | kill didnt take, lets bomb out



	.end
