|
| chkstk.a86
|      Check stack (probe) and allocate stack variables
|
| Called at entry to EACH C-procedure to do 
| allocate local-variables on the stack.  In addition, the stack
| is probed to insure the space is allocated.  
|
| On entry, AX = amount to adjust the stack.
|
|	JGL, 05/82
|
| PROBESLOP defines enough room to insure there is enough room for various
| system needs: sys-call, IO-int, etc.  Also, insures room for C-expression
| evaluation temporaries, and nested procedure call.


PROBESLOP =	256
SIGSEG    =     11


	.data
	.globl	Stkbot
Stkbot: .word   _end                      | stack bottom limit

	.text				
	.globl	chkstk		
chkstk:			
	mov	bx, sp
	sub	bx, ax			| BX -> lowest new stack address
	cmp     bx,Stkbot
	jb      chkst3                  | need to grow
chkst1: pop     ax                      | (ax) = return address
	mov	sp, bx			| set stack
	jmp     @ax                     | return

|
|       sorry, we can't grow the stack anymore.  Send ourselves a
|       "segmentation" signal.

chkst3: call    _getpid                 | (ax) = pid
	push    bp
	mov     bp,sp                   | setup proc preamble in case he
	push    di                      | uses adb to do a traceback
	push    si
	mov     bx,#SIGSEG
	push    bx
	push    ax                      | (pid, SIGSEG)
	call    _kill                   | suicide
	call    __exit                  | kill didnt take, lets bomb out



.end
