/*
	C library - ascii to floating
*/

#include <math.h>
#include <ctype.h>
int _fltu3(){}			/* pull this in if floats are used */

#ifdef XBOOT
# define FP1 fp_1               /* floating 1.0 */
# define FP5 fp_5               /* floating 5.0 */
# define FP10 fp_10             /* floating 10.0 */
  double fp_1, fp_5, fp_10;
#else
# define FP1 1.0
# define FP5 5.0
# define FP10 10.0
#endif

double
atof(p)
register char *p;
{
	register c;
	double fl, flexp, exp5;
	double big;
	double ldexp();
	int nd;
	register eexp, exp, neg, negexp, bexp;

#ifdef XBOOT
	c = 1; fp_1 = c;                /* build fp consts at runtime */
	c = 5; fp_5 = c;
	c = 10; fp_10 = c;
	c = 2;
	big = c;
	for (nd=1; nd < 56; nd++)
		big *= c;               /* compute 2^56 */
#else
	big = 72057594037927936.;  /*2^56*/
#endif
	neg = 1;
	while((c = *p++) == ' ')
		;
	if (c == '-')
		neg = -1;
	else if (c=='+')
		;
	else
		--p;

	exp = 0;
	fl = 0;
	nd = 0;
	while ((c = *p++), isdigit(c)) {
		if (fl<big)
			fl = FP10*fl + (c-'0');
		else
			exp++;
		nd++;
	}

	if (c == '.') {
		while ((c = *p++), isdigit(c)) {
			if (fl<big) {
				fl = FP10*fl + (c-'0');
				exp--;
			}
		nd++;
		}
	}

	negexp = 1;
	eexp = 0;
	if ((c == 'E') || (c == 'e')) {
		if ((c= *p++) == '+')
			;
		else if (c=='-')
			negexp = -1;
		else
			--p;

		while ((c = *p++), isdigit(c)) {
			eexp = 10*eexp+(c-'0');
		}
		if (negexp<0)
			eexp = -eexp;
		exp += eexp;
	}

	negexp = 1;
	if (exp<0) {
		negexp = -1;
		exp = -exp;
	}

#ifdef DEBUG
	printf ("atof: nd=%d exp=%d negexp=%d, fl = %x %x %x %x\n",
		nd, exp, negexp, fl);
#endif

	if((nd+exp*negexp) < -LOGHUGE){
		fl = 0;
		exp = 0;
	}
	flexp = FP1;
	exp5 = FP5;
	bexp = exp;
	for (;;) {
		if (exp&01)
			flexp *= exp5;
		if ((exp>>=1) == 0)
			break;
		exp5 *= exp5;
	}
	if (negexp<0)
		fl /= flexp;
	else
		fl *= flexp;
	fl = ldexp(fl, negexp*bexp);
	if (neg<0)
		fl = -fl;
	return(fl);
}

/* this is here so doscan doesnt need to have any floating point
   code in it.  -Hans, Mar 3, 1981 */
fltrd(p,s, size)
char *p, *s;
int size;
{
	if (size)
		**(double **)p = atof(s);
	else
		**(float **)p = atof(s);
}
