/**     strdup - duplicate string
 *
 *      out = strdup(in);
 *              char *in, *out;
 *
 *      strdup allocates sufficent static memory (malloc) to hold
 *      the string 'in', copies the string there, and returns a pointer
 *      to the new area.
 *
 *      strdup allows a program to make a perminant copy of a string
 *      so that the buffer containing the string can be reused.
 *
 *      strdup returns NULL if 'in' is NULL, thus preserving the
 *      difference between a null string and an empty one.
 *
 *      strdup returns NULL if there was insufficent memory to hold
 *      the duplicate string.
 */

#include <stdio.h>

char *malloc();
char *strcpy();

char *
strdup(in)
    register char *in;
{
	register char *mem;

	if (in == NULL)
		return(NULL);

	mem = malloc(strlen(in)+1);
	if (mem == NULL)
		return(NULL);

	return(strcpy(mem, in));
}
