
| C library -- signal
|
| signal(n, 0);		/* default action on signal(n) */
| signal(n, 1);		/* ignore signal(n)	M000 */
| signal(n, label);	/* call label(n) on signal(n) */
|
| returns old label, only one level.
|
|	arw	 9 Jan 1982	M000
|		- Modified to make the ignore signal argument as
|		  being exactly one.

	.globl	_signal
	.comm	_errno,2
	.sigs = 48.

	.text
_signal:
	mov     bx,sp
	mov     cx,*4(bx)       | (cx) = vector
	mov     bx,*2(bx)       | (bx) = signal number
	cmp     bx,*16.         | max signal
	ja      sig2            | toobig
	mov     ax,bx           | (ax) = signal #, PRESERVE until syscal
	add     bx,bx           | (bx) = 2*sig
	push    sigtab(bx)      | save old value for return
	mov     sigtab(bx),cx   | store users routine addr in table
	and     cx,cx           | zero argument ?
	jz      sig1            | if zero then just give zero to kernel

	cmp	cx,*1           | special ignore argument?		* M000 *
	jz	sig1            | if one then just give one to kernel	* M000 *

	add     bx,bx           | (bx) = 4*sig
	lea     cx,sigvec(bx)   | tell os the addr of our routine

|       (ax) = signal number
|       ((sp)) = old signal value

sig1:   xchg    ax,bx           | (bx) = signal number
	mov     ax,*.sigs
	calli   @Iscadr         | call XENIX
	pop     bx              | (bx) = original table entry
	jb      sig3            | if error
	testb   al,*1           | if ignored, just return
	jnz     sig4
	xchg    ax,bx           | (ax) = previous table entry, not os value
	j       sig4

sig2:
	mov     ax,*22.         | Invalid argument
sig3:
	mov     _errno,ax
	mov     ax,*-1
sig4:
	ret                     | return


|**	sigtrp - Handle signal traps
|
|	When a signal is intercepted, the system calls enters the
|	user-specified signal routine as if an interrupt had occured.
|	The signal routine must do an 'iret' back to the user task's
|	interrupted execution path.
|
|	Naturally, 'c' does not know how to generate this, so we
|	intersperse this 'thunk', which gets control from unix, passes
|	it to the user's routine, then properly restores control
|	to the interrupted execution path.
|
|       ENTRY   ((sp)+6) = return flags
|               ((sp)+4) = return cs
|               ((sp)+2) = return ip
|               ((sp))   = sigvec entry + 3

sigtrp:
|       cli
|       push    ax
|       pop     ax
|       int     *3
	push    bp		| save all registers
	mov     bp,sp
	push    ax
	push    bx
	push    cx
	push    dx
	push    si
	push    di
	mov     ax,*2(bp)       | (ax) = return addr into sigvec
	sub     ax,#sigvec+3    | (ax) = signal number * 4
	shr     ax,*1
	shr     ax,*1           | /4
	push    ax              | pass signal # as param
	add     ax,ax
	xchg    ax,bx
	call    @sigtab(bx)     | call 'c' routine
	pop     di              | remove argument
	pop     di
	pop     si
	pop     dx
	pop     cx
	pop     bx
	pop     ax
	pop     bp              | restore regs
	add     sp,*2           | skip 'sigvec' return addr
	iret


|**	sigvec - signal vector routine
|
|	unix is given an address in this table as the 'user routine'
|	to activate when a signal is received.  This 'routine' simply
|	encodes what the signal number was (via the return address)
|	and lets 'sigtrap' handle things.

	.even                           | make addresses to OS even
sigvec:
	call    sigtrp                 |signal 0
	.byte   0                       | each call is 4 bytes
	call    sigtrp
	.byte   0
	call    sigtrp
	.byte   0
	call    sigtrp
	.byte   0
	call    sigtrp
	.byte   0
	call    sigtrp
	.byte   0
	call    sigtrp
	.byte   0
	call    sigtrp
	.byte   0
	call    sigtrp
	.byte   0
	call    sigtrp
	.byte   0
	call    sigtrp
	.byte   0
	call    sigtrp
	.byte   0
	call    sigtrp
	.byte   0
	call    sigtrp
	.byte   0
	call    sigtrp
	.byte   0
	call    sigtrp
	.byte   0
	call    sigtrp                 |through 16

	.data

|*	User signal vectors
|*
|*	these cells contain the address of the user's signal routine

sigtab: .word   0,0,0,0,0,0,0,0,0
	.word	0,0,0,0,0,0,0,0,0

	.end
